Attribute VB_Name = "Module1"
' Public variables
Public Echo As Boolean        ' Echo On/Off flag.
Public CancelSend As Integer  ' Flag to stop sending a text file.

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

 Type Record
        ID As Integer
        Name As String * 20
End Type


Public Sub AddToArray(arrByte() As Byte, ByVal bVal As Byte)
    On Error Resume Next
    Dim nubd As Integer
    nubd = UBound(arrByte) + 1
    If Err.Number <> 0 Then
        nubd = 0
        ReDim arrByte(0 To 0)
    Else
        ReDim Preserve arrByte(LBound(arrByte) To nubd)
    End If
    
    arrByte(nubd) = bVal
    
    On Error GoTo 0
End Sub

Public Function ByteArrayToString(arrByte() As Byte) As String

    ByteArrayToString = ""
    
    On Error Resume Next
    
    Dim nFrom As Integer
    Dim nTo As Integer
    Dim ch As String
        
    nFrom = LBound(arrByte)
    If Err.Number = 0 Then
        nTo = UBound(arrByte)
        Dim i As Integer
        For i = nFrom To nTo
            'If arrByte(i) = cnstFLAG Then
                ch = Chr(arrByte(i))
            'Else
             '   ch = Trim(str(arrByte(i)))
            'End If
            ByteArrayToString = ByteArrayToString & ch 'Trim(str(arrByte(i)))
        Next
        
    End If
    

   
    
End Function

Public Function crcCheckSum(arrByte() As Byte) As Byte

    crcCheckSum = 0
    
    On Error Resume Next
    
    Dim nFrom As Integer
    Dim nTo As Integer
    
    Dim shift_reg As Byte
    Dim sr_lsb As Byte
    Dim data_bit As Byte
    Dim fb_bit As Byte
    Dim v As Byte
    
    Dim j As Integer
    shift_reg = 0
               
    nFrom = LBound(arrByte)
    If Err.Number = 0 Then
        nTo = UBound(arrByte)
        Dim i As Integer
        For i = nFrom + 2 To nTo - 3         'STX + checksum + ETX
            v = arrByte(i) And &HFF
           For j = 0 To 7
                data_bit = v And &H1
                sr_lsb = shift_reg And &H1
                fb_bit = (data_bit Xor sr_lsb) And &H1    'calculate the feed back bit
                shift_reg = shift_reg \ &H2   ' shift right
                If fb_bit = 1 Then
                    shift_reg = shift_reg Xor &H8C
                End If
                v = v \ &H2   'shift right
            Next j
        Next i
    End If
    crcCheckSum = shift_reg
    On Error GoTo 0
    
End Function


Public Function Rec_crcCheckSum(arrByte() As Byte) As Byte

    Rec_crcCheckSum = 0
    
    On Error Resume Next
    
    Dim nFrom As Integer
    Dim nTo As Integer
    
    Dim shift_reg As Byte
    Dim sr_lsb As Byte
    Dim data_bit As Byte
    Dim fb_bit As Byte
    Dim v As Byte
    
    Dim j As Integer
    shift_reg = 0
               
    nFrom = LBound(arrByte)
    If Err.Number = 0 Then
        nTo = UBound(arrByte) - 3
        Dim i As Integer
        For i = 2 To nTo          'STX + checksum + ETX
            v = arrByte(i) And &HFF
           For j = 0 To 7
                data_bit = v And &H1
                sr_lsb = shift_reg And &H1
                fb_bit = (data_bit Xor sr_lsb) And &H1    'calculate the feed back bit
                shift_reg = shift_reg \ &H2   ' shift right
                If fb_bit = 1 Then
                    shift_reg = shift_reg Xor &H8C
                End If
                v = v \ &H2   'shift right
            Next j
        Next i
    End If
    Rec_crcCheckSum = shift_reg
    On Error GoTo 0
    
End Function



